﻿// By : Codicode.com
// Source : http: //www.codicode.com/art/jquery_endless_div_scroll.aspx
// Licence : Creative Commons Attribution license (http://creativecommons.org/licenses/by/3.0/)

// You can use this plugin for commercial and personal projects.
// You can distribute, transform and use them into your work,
// but please always give credit to www.codicode.com

// The above copyright notice and this permission This notice shall be included in
// all copies or substantial portions of the Software.

(function ($) {
    $.fn.endlessScroll = function (options) {

        var options = $.extend({ width: "400px", height: "100px", steps : -2, speed : 40, mousestop : true }, options);

        var elem = $(this);
        var elemId = $(this).attr("id");
        var istep = options.steps;

        elem.css({ "overflow": "hidden", "width": options.width, "height": options.height, "position": "relative", "left": "0px", "top": "0px" })
        elem.wrapInner("<nobr />");

        elem.mouseover(function () {
            if (options.mousestop) { istep = 0; }
        })
        elem.mouseout(function () {
            istep = options.steps;
        });
        
        elem.wrapInner("<div id='" + elemId + "1' />");
        var e1 = $('#' + elemId + "1");
        e1.css({ "position": "absolute" }).clone().attr('id', elemId + "2").insertAfter(e1);
        var e2 = $('#' + elemId + "2");
        Repos(e1, e2, options.steps > 0);

        var refreshId = setInterval(function () {
            e1.css({ "left": (parseInt(e1.css("left")) + istep) + "px" });
            e2.css({ "left": (parseInt(e2.css("left")) + istep) + "px" });
            if ((parseInt(e1.css("left")) < 0) || (parseInt(e1.css("left")) > e1.width())) {
                Repos(e1, e2, options.steps > 0);
            }
        }, options.speed);


        function Repos(e1, e2, fwd) {
            e1.css({ "left": (fwd) ? "0px" : e1.width() + "px" });
            e2.css({ "left": (fwd) ? (-1 * e1.width()) + "px" : "0px" });
        }

        return elem;
    }
})(jQuery);